<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Accounts' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div class="top">
      <b-row>
        <b-col class="left-col">
          <span>
            <img
              src="@/assets/icons/sphere_planet.svg"
              alt="Icône sphères"
            />
            {{ spheresCount }} groupes d'organisations
          </span>
          <div
            class="add-btn"
            @click="$router.push({ name: 'AddSphere' })"
          >
            <b-icon-plus />
            Ajouter un groupe d'organisations
          </div>
          <SearchTable
            :placeholder="'Rechercher un groupe d\'organisations'"
            :searchFunction="SEARCH_USERGROUPS_LIST"
            @loading="loadSearch"
          />
        </b-col>
        <b-col class="right-col">

        </b-col>
      </b-row>
    </div>
    <div class="custom-table">
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      >
        <CustomTable
          :routeTo="'SphereDetail'"
          :fields="fields"
          :items="items"
          :defaultSorting="{
            sortedUp: true,
            sortedDown: false,
            sortedField: 'display_name'
          }"
          :sortFunction="GET_USERGROUPS_SPHERES_LIST"
          :selectable="false"
          @sorted="setTableSorted"
          @delete="openDeleteModal"
          @loading="setTableLoader"
        />
        <Pagination
          :nbPages="Math.ceil(spheresCount/50)"
          @change-page="changeTablePage"
        />
      </b-overlay>
    </div>
    <DeleteSphere
      :open="deletingSphere"
      :usergroup="sphereToDelete"
      @hide="deletingSphere = false"
      @update="updateUsergroupsList"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import SearchTable from '@/components/SearchTable.vue';
import DeleteSphere from '@/components/Modals/DeleteSphere.vue';

import { mapState, mapActions } from 'vuex';

export default {
  name: 'Spheres',

  components: {
    CustomTable,
    Pagination,
    SearchTable,
    DeleteSphere
  },

  data() {
    return {
      loading: false,
      fields: [
        {
          key: 'Sphère',
          apiName: 'display_name',
          sortable: true,
          width: '40%',
          centered: false
        },
        {
          key: 'Date de création',
          apiName: 'creation_date',
          sortable: true,
          width: '',
          centered: true
        },
        {
          key: 'Nombre d\'organisations',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Supprimer',
          sortable: false,
          width: '',
          centered: true
        }
      ],
      tableSorted: {
        direction: '',
        field: 'display_name'
      },
      deletingSphere: false,
      sphereToDelete: null
    };
  },

  computed: {
    ...mapState('usergroups', [
      'spheres',
      'spheresCount',
      'isSpheresSearched'
    ]),
    items() {
      return this.spheres.map(el => {
        return {
          id: el.id,
          'Sphere': el.display_name,
          'Date de création': new Date(el.creation_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Nombre d\'organisations': el.children.length
        }
      });
    }
  },

  created() {
    if (this.spheres.length === 0 || this.isSpheresSearched) {
      this.getData();
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.deletingSphere = false
    });
  },

  methods: {
    ...mapActions('usergroups', [
      'GET_USERGROUPS_SPHERES_LIST',
      'SEARCH_USERGROUPS_LIST'
    ]),

    getData() {
      this.loading = true;
      this.GET_USERGROUPS_SPHERES_LIST({...this.tableSorted}).then(() => {
        this.loading = false;
      });
    },

    openDeleteModal(e) {
      this.deletingSphere = true;
      this.sphereToDelete = e;
    },

    updateUsergroupsList() {
      this.getData();
    },

    changeTablePage(e) {
      this.loading = true;
      this.GET_USERGROUPS_SPHERES_LIST({...this.tableSorted, page: e}).then(() => {
        this.loading = false;
      });
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    loadSearch(e) {
      this.loading = e;
    }
  }
}
</script>
